#line 9 "macros.m4"

#line 26


#line 1 "sha256-test.m4"
#include "sha.h"


#line 3
#include "testutils.h"
#line 3

#line 3
#include <string.h>
#line 3
#include <stdlib.h>
#line 3

#line 3
int main (int argc, char **argv)
#line 3
{
#line 3


struct sha256_ctx ctx;
uint8_t digest[SHA256_DIGEST_SIZE];

sha256_init(&ctx);
sha256_update(&ctx, 3, "abc");
sha256_final(&ctx);
sha256_digest(&ctx, SHA256_DIGEST_SIZE, digest);

if (!(!memcmp (digest, decode_hex_dup("ba7816bf8f01cfea 414140de5dae2223 b00361a396177a9c b410ff61f20015ad"), SHA256_DIGEST_SIZE)))
#line 15
  abort();

memset(digest, 0, SHA256_DIGEST_SIZE);
sha256_digest(&ctx, SHA256_DIGEST_SIZE - 1, digest);

if (!(!memcmp (digest, decode_hex_dup("ba7816bf8f01cfea 414140de5dae2223 b00361a396177a9c b410ff61f2001500"), SHA256_DIGEST_SIZE)))
#line 22
  abort();

sha256_init(&ctx);
sha256_update(&ctx, 56, "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq");
sha256_final(&ctx);
sha256_digest(&ctx, SHA256_DIGEST_SIZE, digest);

if (!(!memcmp (digest, decode_hex_dup("248d6a61d20638b8 e5c026930c3e6039 a33ce45964ff2167 f6ecedd419db06c1"), SHA256_DIGEST_SIZE)))
#line 31
  abort();

sha256_init(&ctx);
sha256_update(&ctx, 112, "abcdefghbcdefghicdefghijdefghijkefghijklfghijklmghijklmnhijklmno"
			 "ijklmnopjklmnopqklmnopqrlmnopqrsmnopqrstnopqrstu");
sha256_final(&ctx);
sha256_digest(&ctx, SHA256_DIGEST_SIZE, digest);

if (!(!memcmp (digest, decode_hex_dup("cf5b16a778af8380 036ce59e7b049237 0b249b11e8f07a51 afac45037afee9d1"), SHA256_DIGEST_SIZE)))
#line 41
  abort();
#line 5 "macros.m4"
  /* Avoid warnings for argc and argv unused */
  (void) argc; (void) argv;
  return 0;
}
